//
//  ACDGen+NSMutableStringExtensions.swift
//  ACDGen
//
//  Created by Vanderlei Martinelli on 2015-07-15.
//  Copyright © 2015 Alecrim. All rights reserved.
//

import Foundation

extension NSMutableString {
    
    func appendLine() {
        self.append("\n")
    }
    
    func appendLine(_ aString: String, indentLevel: Int = 0) {
        for _ in 0..<indentLevel {
            self.append("    ")
        }
        
        self.append("\(aString)\n")
    }
    
    func appendHeader(_ name: String, type: SourceCodeFileType) {
        if type.canOverwrite {
            self.appendLine("//")
            self.appendLine("//  " + type.fullName(fromName: name))
            self.appendLine("//")
            self.appendLine("//  This code was generated by AlecrimCoreData code generator tool.")
            self.appendLine("//")
            self.appendLine("//  Changes to this file may cause incorrect behavior and will be lost if")
            self.appendLine("//  the code is regenerated.")
            self.appendLine("//")
            self.appendLine()
        }
        else {
//            let dateFormatter = NSDateFormatter()
//            dateFormatter.dateFormat = "yyyy-MM-dd"
//            let dateString = dateFormatter.stringFromDate(NSDate())
//            
            self.appendLine("//")
            self.appendLine("//  " + type.fullName(fromName: name))
//            self.appendLine("//")
//            self.appendLine("//  Created on \(dateString).")
            self.appendLine("//")
            self.appendLine()
        }
    }
    
}

